Attribute VB_Name = "mod_SetSubDatasheetNone"
Option Compare Database
Option Explicit

'*************** Code Start *****************************************************
' download:
'  http://msaccessgurus.com/VBA/Code/table_SetSubDatasheetNone.htm
'-------------------------------------------------------------------------------
' Purpose  : Set subdatasheet to [None] in all tables where needed
' Author   : crystal (strive4peace), based on code by Allen Vrowne
' License  : below code
' Code List: www.msaccessgurus.com/code.htm
'-------------------------------------------------------------------------------
'           GetMyDayNames
'-------------------------------------------------------------------------------
Public Sub SetSubDatasheetNone()
  
   'crystal (strive4peace) 061027, 160905, 200423
   'strive4peace
   'based on code written by Allen Browne
   '  Microsoft Access Flaws - Problem properties by Allen Browne
   '  http://allenbrowne.com/bug-09.html
 
   'set the Subdatasheet property to [None]
   'in all user tables
  
   'needs reference to
   'Microsoft DAO Library
 
   Dim tdf As DAO.TableDef _
      , prop As DAO.Property
      
   Dim iCountDone As Integer _
      , iCountChecked As Integer _
      , bChanged As Boolean _
      , sName As String
  
   'skip errors
   On Error Resume Next
   
   iCountDone = 0
   iCountChecked = 0
   For Each tdf In CurrentDb.TableDefs
      'skip Microsoft System tables
      If Left(tdf.Name, 4) <> "Msys" Then

         bChanged = False
         iCountChecked = iCountChecked + 1
         Err.Number = 0
         sName = tdf.Properties("SubdatasheetName")
         If Err.Number > 0 Then

            Set prop = tdf.CreateProperty( _
               "SubdatasheetName", dbText, "[None]")

            tdf.Properties.Append prop
            bChanged = True
         Else
            'thanks, Allen!
            If tdf.Properties("SubdatasheetName") <> "[None]" Then
               tdf.Properties("SubdatasheetName") = "[None]"
               bChanged = True
            End If
         End If
         If bChanged = True Then
            iCountDone = iCountDone + 1
         End If
      End If
   Next tdf
   
   Set prop = Nothing
   Set tdf = Nothing
   
   MsgBox iCountChecked & " tables checked" & vbCrLf & vbCrLf _
      & "Reset SubdatasheetName property to [None] in " _
      & iCountDone & " tables" _
      , , "Reset Subdatasheet to None"
   
End Sub

'   You may freely use and share this code
'     provided this license notice and comment lines are not changed;
'     code may be modified provided you clearly note your changes.
'   You may not sell this code alone, or as part of a collection,
'     without my handwritten permission.
'   Use at your own risk.
'   ~ crystal (strive4peace)  www.msaccessgurus.com
'*************** Code End *******************************************************
